<?php 
class Modelo extends AppObjeto {
	
	//Propiedades
	protected $marca;
	protected $nombre;
	protected $codigo;
	protected $variante;
	protected $categoria;

	
	protected $nombre_marca;
	
			
	/* para conectar con bd */
	protected static $_aliasTabla = 'a';
	protected static $_nombreTabla = 'MODELO';
	protected static $_campoPK = 'COD_MOD';
	
	
	// InitMetaDatos
	protected static function initMetaDatos(){
		self::addPropiedadBD('a', 'MARCA', 'marca', self::META_VARCHAR);
		self::addPropiedadBD('a', 'NOMMARCA', 'nombre_marca', self::META_VARCHAR);
		self::addPropiedadBD('a', 'NOMBRE', 'nombre', self::META_VARCHAR);
		self::addPropiedadBD('a', 'CODIGO', 'codigo', self::META_VARCHAR);
		self::addPropiedadBD('a', 'VARIANTE', 'variante', self::META_VARCHAR);
		self::addPropiedadBD('a', 'CATEGORIA', 'categoria', self::META_VARCHAR);
	}
	
	/*
	 * Devuelve los clientes para autocompletar 
	 * @param array $params: busqueda
	 * @return AppListado
	 * 
	 */
	public static function autocompletar($params){
		$select = self::selectObjeto();
		$select->columns(array('label'=> new Zend_Db_Expr('NOMMARCA || \' - \' || NOMBRE'),'value'=>new Zend_Db_Expr('NOMBRE')));
		$select->where("MARCA in ('AU','BA','BE','AVI','BM','BU','CH','CHE','CI','DA','DW','EX', 'FE','FI','FO','HO','LA','MER','MN','HY','IV','JE','JG','KI','LE','MA','ME','MY','MZ','NI','OP','PA','PD','PE','PI','PO','RA','RE','RL','SB','SK','SE','SM','SU','TE','TO','VO','VW','HU','CAD','TES','ZI')");
		// buscar por nombre en cualquier orden
		if (isset($params['busqueda']) && $params['busqueda']) {
			$palabras = explode(' ', $params['busqueda']);
			$sql = array();
			foreach ($palabras as $palabra){
				if ($palabra){
					$sql[] = 'NOMBRE like \'%'.$palabra.'%\' or NOMMARCA like \'%'.$palabra.'%\'';
				}
			}
			$sql = implode(' and ', $sql);
			$select->where($sql);
		}
		$select->order(array('nommarca','nombre'));
		$resultado = self::selectExecute($select);
		return $resultado;
 	} 
 	
}